﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication38
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new DummyError();
        }

        public class DummyError
        {
            public string Property
            {
                get
                {
                    throw new NotImplementedException();
                }
                set
                {
                    throw new NotImplementedException();
                }
            }
        }



        public static bool GetEnableDirectionStates(DependencyObject obj)
        {
            return (bool)obj.GetValue(EnableDirectionStatesProperty);
        }

        public static void SetEnableDirectionStates(DependencyObject obj, bool value)
        {
            obj.SetValue(EnableDirectionStatesProperty, value);
        }

        // Using a DependencyProperty as the backing store for EnableDirectionStates.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty EnableDirectionStatesProperty =
            DependencyProperty.RegisterAttached("EnableDirectionStates", typeof(bool), typeof(MainWindow), new PropertyMetadata(false, OnEnableDirectionStatesPropertyChanged));

        private static void OnEnableDirectionStatesPropertyChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            ToolTip tooltip = d as ToolTip;
            if (tooltip != null)
            {
                var subscribing = (bool)e.NewValue;
                if (subscribing)
                {
                    tooltip.Opened += tooltip_Opened;
                }
                else
                {
                    tooltip.Opened -= tooltip_Opened;
                }
            }
        }

        static void tooltip_Opened(object sender, RoutedEventArgs e)
        {
            ToolTip tooltip = (ToolTip)sender;
            FrameworkElement control = tooltip.PlacementTarget as FrameworkElement;

            var tooltipPointInTargetCoordinates = tooltip.TranslatePoint(new Point(0, 0), control);

            if (tooltipPointInTargetCoordinates.X > 0)
            {
                VisualStateManager.GoToState((FrameworkElement)tooltip, "PlacedToTheRight", false);
            }
            else
            {
                VisualStateManager.GoToState((FrameworkElement)tooltip, "PlacedToTheLeft", false);
            }
        }
    }
}
